
%% author: Alvaro Feito, 6 July 2009
%% Imperial College London
%% based on code from Kenneth Pregnell, Martin Plenio, Alvaro Feito
%% used in arXiv:0807.2444 and arXiv:0906.3440

%% This is a short UNCOMMENTED VERSION.

clear all
%load('measured_probabilities.csv')';   %% this would import the data
PD=example_photon_number_detector_prob_distrib(25); %% Example Distribution

si = size(PD);                   %Determines size of the data set
imax = si(2);                    % Number of data points
mmax = floor(10+PD(1,si(2)));    % Determine cut-off in Fock space 


%%%%%% F matrix generation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i1 = 1:2*(mmax+1)                                         %
    bino(i1,1) = 1;                                           %
    for i2 = 2:i1
        m1=i1-1;
        m2=i2-1;
        bino(i1,i2) = bino(i1,i2-1)*(m1-m2+1)/m2;
    end
end
fac(1)=1;
for i1=2:2*mmax
    fac(i1)=fac(i1-1)*(i1-1);
end
for i1 = 0:mmax+1                                             %
    ga(i1+1)=gamma(i1+1/2);                                   %
end                                                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

Fmix = zeros(mmax,imax);
for i1 = 1:mmax
    for i2 = 1:imax
        s = 2; % Standard deviation, 
                                     
        m = i1-1;
        for r = 0:m
            c1 = bino(2*m+1,2*r+1);
            c2 = (2*s*s/(1+2*s*s))^(r)*sqrt(2/(1+2*s*s));
            c3 = (sqrt(PD(1,i2))/(1+2*s*s))^(2*(m-r));
            Fmix(i1,i2) = Fmix(i1,i2) + c1*c2*c3*ga(r+1);
        end
        Fmix(i1,i2) = Fmix(i1,i2)*(sqrt(1/2/pi)/fac(i1))*exp(-PD(1,i2)/(1+2*s*s));
    end
end

%%%%%%%%%%%% OPTIMISATION %%%%%%%%%%%%%

          
povre = sdpvar(si(1)-1,mmax);  %% the regularized POVM (new sdp-variable)
Min_Object_re = (PD(2:si(1),:)-povre*Fmix);  %% this is (P - F*POV)
          
        
          
smooth=0;
for k=1:si(1)-1
   tic
   for i=1:mmax-1
       smooth = smooth + (povre(k,i)-povre(k,i+1))^2;
   end
   toc
end


sm=0.1;  %%% Weight of the quadratic regularization (or penalty)

%%%%%%%  SDP Optimization %%%%%%%%%%%%%%%%%%%%%%%%%%
                                                   %
CON = set(povre(:) > 0); %positive povm           % 
CON = CON + set(sum(povre)==1); % adds to one     %
solvesdp(CON,norm(Min_Object_re,'fro')+sm*smooth)  %
                                                   %
%%%%%%%  SDP Optimization %%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%% RESULT  (converted from sdp-variable do double) %%

POVMre = double(povre);                          %
                            

bar3(POVMre')


